Prime XOR - HackerRank


https://www.hackerrank.com/challenges/prime-xor/problem
https://suzyz.github.io/2017/09/16/prime-xor/
Given an array A with N integers between 3500 and 4500, find the number of unique multisets that can be formed using elements from the array such that the bitwise XOR of all the elements of the multiset is a prime number.

Solution

First, we notice that 3500 ≤ a[i] ≤ 4500. So the bitwise XOR of any multiset is in the range [0,(2^13)-1].
Let count[i] be the number of i in array A.
Let f[i,j] be the number of unique multisets whose elements are within [3500,i], and whose XOR equals to j. So we have

f[i,j] = ((f[i-1,j] × (count[i]/2 + 1)) % mo + (f[i-1,j^i] × ((count[i]+1)/2) % mo)) %mo
int n,count[maxd];
bool is_prime[max_xor+2];
long long f[2][max_xor+2];
void init()
{
for(int i=2;i<=max_xor;i++) is_prime[i]=true;
for(int i=2;i<=max_xor;i++)
if(is_prime[i])
{
int j=i<<1;
while(j<=max_xor)
{
is_prime[j]=false;
j+=i;
}
}
}
int main()
{
init();
int T;
scanf("%d",&T);
while(T)
{
T--;
memset(count,0,sizeof(count));
memset(f,0,sizeof(f));
scanf("%d",&n);
int tmp;
for(int i=1;i<=n;i++)
{
scanf("%d",&tmp);
count[tmp]++;
}
f[0][0]=1;
int flag=1;
for(int i=3500;i<=4500;i++)
{
for(int j=0;j<=max_xor;j++)
if(count[i]==0)
f[flag][j]=f[1-flag][j];
else
f[flag][j] = (f[1-flag][j]*(count[i]/2 + 1) % mo + f[1-flag][j^i]*((count[i]+1)/2) % mo) % mo;
flag=1-flag;
}
long long ans=0;
for(int j=0;j<=max_xor;j++)
if(is_prime[j])
ans = (ans + f[1-flag][j])%mo;
printf("%lld\n",ans);
}
This problem can be solved using dynamic programming and pigeonhole principle. Using sieve of Eratosthenes, mark all the primes lying between  to . Create a hashmap which stores the count of occurrences of all the array elements. Note that since the xor-sum of any subset of array elements will not exceed . Using this property, we can write a  dynamic programming solution with  constant factor such that  would store the count of subsets that can be formed with the first  elements such that the xor-sum of the elements in the subset is .
int a[5025];
vector<int> v;
bool prime[9025];
long long mem[2][8192];
void sieve( )   
{
    memset(prime, true, sizeof(prime));
    prime[1]=false, prime[0]=false; 
    for(int i=4;i<=9000;i+=2)
    prime[i]=false;
    for (int p=3; p*p<=9000;p+=2)
 {
        if (prime[p] == true)
        {
            for (int i=p*p; i<=9000; i += 2*p)
                prime[i] = false;
        }
    }

}
int main() {
//freopen("input2.txt","r",stdin);
//freopen("output2.txt","w",stdout);
clock_t begin, end;
begin = clock();
int t;
sieve();
cin >> t;
while(t--) {
    int n;
    cin >> n;
    v.clear();
    memset(a,0,sizeof(a));
    for(int i=0;i<n;i++) {
        int x;
        scanf("%d",&x);
        a[x]+=1;
    }
    for(int i=3500;i<4525;i++)
        if(a[i]>=1)
            v.push_back(i);
    memset(mem,0,sizeof(mem));
    mem[0][0]=1;
    int flag=1;
    int k = v.size();
    for(int i=1;i<=k;i++) {
        for(int j=0;j<8192;j++) {
            mem[flag][j] = (mem[flag^1][j]*(1+(a[v[i-1]])/2))%mod + (mem[flag^1][j^v[i-1]]*((a[v[i-1]]+1)/2))%mod;
            if(mem[flag][j]>=mod)
                mem[flag][j]%=mod;
        }
        flag = flag^1;

    }
    long long ans=0;
    long long res=0;
    for(int i=1;i<8192;i++) {
        if(prime[i]){

            res+= mem[flag^1][i];
            res%=mod;
        }
    }
    cout << res << endl;
}
end = clock();
//cout << ((float) (end) - (float) (begin)) / CLOCKS_PER_SEC << endl;
fclose(stdout);
return 0;

Explanation of Flag

This is a standard approach to reduce memory usage when using dynamic programming.
The idea is that often each row of a DP array only depends on the previous row. In this case, instead of storing the whole 2d DP[i][j] array, you can instead just use 2 rows of the array.
In other words, DP[i][j] is stored in mem[0][j] if i is even, and in mem[1][j] if i is odd. The mem array is reused multiple times and after each iteration holds the most recent two rows of the full DP array.

Explanation of recurrence

Suppose we have 5 duplicates of a certain value v. There are 1+5/2 ways of making an xor of 0 (take either 0,2 or 4 copies). There are (1+5)/2 ways of making an xor of v (take either 1,3 or 5 copies).
So to make the new value j, we can either start with j and add 0,2 or 4 copies of v, or start with j^v and add 1,3 or 5 copies

LCA of Deepest Nodes in Binary Tree - Facebook


https://www.cnblogs.com/EdwardLiu/p/6551606.html
给一个 二叉树 , 求最深节点的最小公共父节点
     1
  2   3
     5  6    return 3.

       1  
    2   3
4      5 6   retrun 1. 
先用 recursive  , 很快写出来了, 要求用 iterative 。 时间不够了。。。
复制代码
Recursion: 返回的时候返回lca和depth每个node如果有大于一个子节点的depth相同就返回这个node,如果有一个子节点depth更深就返回个子节点lca,这个o(n)就可以了
Iteration: tree的recursion换成iteration处理,一般用stack都能解决吧(相当于手动用stack模拟recursion)。感觉这题可以是一个样的做法,换成post order访问,这样处理每个node的时候,左右孩子的信息都有了,而且最后一个处理的node一定是tree root
我的想法是要用hashMap<TreeNode, Info>
class Info{
  int height;
  TreeNode LCA;
}

 5     private class ReturnVal {
 6         public int depth;   //The depth of the deepest leaves on the current subtree
 7         public TreeNode lca;//The lca of the deepest leaves on the current subtree
 8 
 9         public ReturnVal(int d, TreeNode n) {
10             depth = d;
11             lca = n;
12         }
13     }
14 
15     public TreeNode LowestCommonAncestorOfDeepestLeaves(TreeNode root) {
16         ReturnVal res = find(root);
17         return res.lca;
18     }
19 
20     private ReturnVal find(TreeNode root) {
21         if(root == null) {
22             return new ReturnVal(0, null);
23         } else {
24             ReturnVal lRes = find(root.left);
25             ReturnVal rRes = find(root.right);
26 
27             if(lRes.depth == rRes.depth) {
28                 return new ReturnVal(lRes.depth+1, root);
29             } else {
30                 return new ReturnVal(Math.max(rRes.depth, lRes.depth)+1, rRes.depth>lRes.depth?rRes.lca:lRes.lca);
31             }
32         }
33     }

find lowest common ancestor among deepest nodes in k-nary tree
前⼏几年年的经典题


Difference of two large numbers


https://blog.csdn.net/lichong_87/article/details/6860329

https://www.geeksforgeeks.org/difference-of-two-large-numbers/
Given two numbers as strings. The numbers may be very large (may not fit in long long int), the task is to find difference of these two numbers.

We can avoid the first two string reverse operations by traversing them from end. Below is optimized solution.
static boolean isSmaller(String str1, String str2)
{
    // Calculate lengths of both string
    int n1 = str1.length(), n2 = str2.length();
  
    if (n1 < n2)
        return true;
    if (n2 > n1)
        return false;
  
    for (int i = 0; i < n1; i++)
    {
        if (str1.charAt(i) < str2.charAt(i))
            return true;
        else if (str1.charAt(i) > str2.charAt(i))
            return false;
    }
    return false;
}
  
// Function for finding difference of larger numbers
static String findDiff(String str1, String str2)
{
    // Before proceeding further, make sure str1
    // is not smaller
    if (isSmaller(str1, str2))
    {
        String t = str1; 
        str1 = str2;
        str2 = t;
    }
  
    // Take an empty string for storing result
    String str = "";
  
    // Calculate lengths of both string
    int n1 = str1.length(), n2 = str2.length();
    int diff = n1 - n2;
  
    // Initially take carry zero
    int carry = 0;
  
    // Traverse from end of both strings
    for (int i = n2 - 1; i >= 0; i--)
    {
        // Do school mathematics, compute difference of
        // current digits and carry
        int sub = (((int)str1.charAt(i + diff) - (int)'0') -
                    ((int)str2.charAt(i) - (int)'0') - carry);
        if (sub < 0)
        {
            sub = sub+10;
            carry = 1;
        }
        else
            carry = 0;
  
        str += String.valueOf(sub);
    }
  
    // subtract remaining digits of str1[]
    for (int i = n1 - n2 - 1; i >= 0; i--)
    {
        if (str1.charAt(i) == '0' && carry > 0)
        {
            str += "9";
            continue;
        }
        int sub = (((int)str1.charAt(i) - (int)'0') - carry);
        if (i > 0 || sub > 0) // remove preceding 0's
            str += String.valueOf(sub);
        carry = 0;
  
    }
  
    // reverse resultant string 
    return new StringBuilder(str).reverse().toString();
}



This is simple based on school mathematics. We traverse both strings from end, one by one subtract digits.
1) Reverse both strings.
2) Keep subtracting digits one by one from 0’th index (in reversed strings) to end of smaller string, append the diff if it’s positive to end of result. If difference(diff) is negative then add 10 and keep track of carry as 1 if it’s positive then carry is 0.
3) Finally reverse the result.
// Function for find difference of larger numbers
static String findDiff(String str1, String str2)
{
    // Before proceeding further, make sure str1
    // is not smaller
    if (isSmaller(str1, str2))
    {
        String t = str1;
        str1 = str2;
        str2 = t;
    }
  
    // Take an empty string for storing result
    String str = "";
  
    // Calculate length of both string
    int n1 = str1.length(), n2 = str2.length();
  
    // Reverse both of strings
    str1 = new StringBuilder(str1).reverse().toString();
    str2 = new StringBuilder(str2).reverse().toString();
      
    int carry = 0;
  
    // Run loop till small string length
    // and subtract digit of str1 to str2
    for (int i = 0; i < n2; i++)
    {
        // Do school mathematics, compute difference of
        // current digits
        int sub = ((int)(str1.charAt(i)-'0') - 
                   (int)(str2.charAt(i)-'0')-carry);
          
        // If subtraction is less then zero
        // we add then we add 10 into sub and
        // take carry as 1 for calculating next step
        if (sub < 0)
        {
            sub = sub + 10;
            carry = 1;
        }
        else
            carry = 0;
  
        str += (char)(sub + '0');
    }
  
    // subtract remaining digits of larger number
    for (int i = n2; i < n1; i++)
    {
        int sub = ((int)(str1.charAt(i) - '0') - carry);
          
        // if the sub value is -ve, then make it positive
        if (sub < 0)
        {
            sub = sub + 10;
            carry = 1;
        }
        else
            carry = 0;
              
        str += (char)(sub + '0');
    }
  
    // reverse resultant string
    return new StringBuilder(str).reverse().toString();
}

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts